import { defineStore } from 'pinia'
import { Profile } from '/@/components/shopSelector/types'
import { request } from '../utils/service'
import { ref, Ref } from 'vue'
import { Session } from '/@/utils/storage';


export const useShopInfo = defineStore('shopInfo', () => {
  const profile: Ref<Profile> = ref({
    id: 0,
    profile_id: "",
    account_name: "",
    time_zone: "",
    advertiser_id: "",
    country_code: "",
    currency_code: "",
    marketplace_str_id: ""
  })

  function updateShopInfo(obj: Profile) {
    profile.value.id = obj.id
    profile.value.profile_id = obj.profile_id
    profile.value.account_name = obj.account_name
    profile.value.time_zone = obj.time_zone
    profile.value.advertiser_id = obj.advertiser_id
    profile.value.country_code = obj.country_code
    profile.value.currency_code = obj.currency_code
    profile.value.marketplace_str_id = obj.marketplace_str_id
    Session.set('shopInfo', profile.value);
  }

  async function reqShopInfo(id: number) {
    return request({
      url: '/api/adManage/profiles/' + id + '/',
      method: 'GET'
    })
  }

  async function setShopInfo(id: number) {
    if (Session.get('shopInfo')) {
      profile.value = Session.get('shopInfo');
    } else {
      let resp: any = await reqShopInfo(id);
      updateShopInfo(resp.data)
    }
  }

  return { profile, updateShopInfo }
})
